//
// OSRNFSDEF.H
//
// Shared definitions between OSR NFS Sample File System and
// OSR Sample Network Provider DLL
//
#ifndef __OSR_OSRNFSDEF_H__
#define __OSR_OSRNFSDEF_H__ (1)


#ifndef FILE_DEVICE_OSRNFS
    //
    // The following value is arbitrarily chosen from the space defined by Microsoft as being "for
    // non-Microsoft use".
    //
    #define FILE_DEVICE_OSRNFS 48030
#endif

//
// Defines
//
#define OSRNFS_HOST_NAME_SIZE 50

#define OSRNFS_SERVERS_SUPPORTED 20

//
// Shared Structures
//

//
// Server Table
//
typedef struct _OSRNFS_SERVER
    {
    CHAR    Name[OSRNFS_HOST_NAME_SIZE];
    ULONG   Address;
    USHORT  MountPort;
    USHORT  NFSPort;
    } OSRNFS_SERVER, * POSRNFS_SERVER;

typedef struct _OSRNFS_INIT
    {
    CHAR    HostName[OSRNFS_HOST_NAME_SIZE];
    ULONG   KnownServers;
    OSRNFS_SERVER   Servers[1];
    } OSRNFS_INIT, * POSRNFS_INIT;

//
// IOCTL definitions
// (Temporary codes for testing)
//
#define IOCTL_OSRNFS_MOUNT      CTL_CODE(FILE_DEVICE_OSRNFS, 2049, METHOD_NEITHER, FILE_ANY_ACCESS)
#define IOCTL_OSRNFS_DIRECTORY  CTL_CODE(FILE_DEVICE_OSRNFS, 2050, METHOD_NEITHER, FILE_ANY_ACCESS)
#define IOCTL_OSRNFS_RPCCALL    CTL_CODE(FILE_DEVICE_OSRNFS, 2051, METHOD_NEITHER, FILE_ANY_ACCESS)
#define IOCTL_OSRNFS_READ       CTL_CODE(FILE_DEVICE_OSRNFS, 2052, METHOD_NEITHER, FILE_ANY_ACCESS)
#define IOCTL_OSRNFS_WRITE      CTL_CODE(FILE_DEVICE_OSRNFS, 2053, METHOD_NEITHER, FILE_ANY_ACCESS)
#define IOCTL_OSRNFS_NEWDIR     CTL_CODE(FILE_DEVICE_OSRNFS, 2054, METHOD_NEITHER, FILE_ANY_ACCESS)
#define IOCTL_OSRNFS_CREATE     CTL_CODE(FILE_DEVICE_OSRNFS, 2055, METHOD_NEITHER, FILE_ANY_ACCESS)

//
// Codes for FSD
// 
#define IOCTL_OSRNFS_INIT       CTL_CODE(FILE_DEVICE_OSRNFS, 2100, METHOD_NEITHER, FILE_ANY_ACCESS)
#define IOCTL_OSRNFS_ENUM       CTL_CODE(FILE_DEVICE_OSRNFS, 2101, METHOD_NEITHER, FILE_ANY_ACCESS)

#endif

